unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, MSI_Security, ComCtrls, ExtCtrls, StdCtrls;

type
  TwndMain = class(TForm)
    pAV: TPanel;
    lvAV: TListView;
    pAS: TPanel;
    lvAS: TListView;
    pFW: TPanel;
    lvFW: TListView;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    SC: TMiTeC_Security;
  public
    procedure RefreshData;
  end;

var
  wndMain: TwndMain;

implementation

uses MiTeC_StrUtils;

{$R *.dfm}

procedure TwndMain.Button1Click(Sender: TObject);
begin
  RefreshData
end;

procedure TwndMain.FormCreate(Sender: TObject);
begin
  {$IFDEF THEMESUPPORT}
  pAV.ParentBackground:=False;
  pAS.ParentBackground:=False;
  pFW.ParentBackground:=False;
  {$ENDIF}

  SC:=TMiTeC_Security.Create(Self);
  RefreshData;
end;

procedure TwndMain.RefreshData;
var
  i: Integer;
begin
  lvAV.Items.Clear;
  lvAS.Items.Clear;
  lvFW.Items.Clear;
  SC.RefreshData;
  for i:=0 to SC.Count-1 do begin
    if SC.Items[i].Typ=sptAntiVirus then
      with lvAV.Items.Add do begin
        Caption:=SC.Items[i].Name;
        SubItems.Add(SC.Items[i].Version);
        SubItems.Add(GetSecurityProductStateStr(SC.Items[i].State));
        SubItems.Add(SC.Items[i].Path);
      end
    else if SC.Items[i].Typ=sptAntiSpyware then
      with lvAS.Items.Add do begin
        Caption:=SC.Items[i].Name;
        SubItems.Add(SC.Items[i].Version);
        SubItems.Add(GetSecurityProductStateStr(SC.Items[i].State));
        SubItems.Add(SC.Items[i].Path);
      end
    else if SC.Items[i].Typ=sptFirewall then
      with lvFW.Items.Add do begin
        Caption:=SC.Items[i].Name;
        SubItems.Add(SC.Items[i].Version);
        SubItems.Add(GetSecurityProductStateStr(SC.Items[i].State));
        SubItems.Add(SC.Items[i].Path);
      end;
  end;
end;

end.
