unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, MSI_Defs, MSI_NetCreds, ComCtrls;

type
  TForm1 = class(TForm)
    List: TListView;
    bSave: TButton;
    sd: TSaveDialog;
    bClose: TButton;
    bRefresh: TButton;
    Memo: TMemo;
    bCM: TButton;
    bRunAsAdmin: TButton;
    bBackup: TButton;
    sdb: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure bSaveClick(Sender: TObject);
    procedure bCloseClick(Sender: TObject);
    procedure cmRefresh(Sender: TObject);
    procedure ListSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure bCMClick(Sender: TObject);
    procedure bRunAsAdminClick(Sender: TObject);
    procedure bBackupClick(Sender: TObject);
  private
    NC: TMiTeC_NetCreds;
  public
  end;

function GetTypeStr(AValue: cardinal): string;

var
  Form1: TForm1;

implementation

uses MiTeC_Routines, MiTeC_SIF;

{$R *.dfm}

function GetTypeStr(AValue: cardinal): string;
begin
  case AValue of
    1: Result:='Generic';
    2: Result:='Domain Password';
    3: Result:='Domain Certificate';
    4: Result:='Domain Visible Password';
    5: Result:='Generic Certificate';
    6: Result:='Domain Extended';
    7: Result:='Maximum';
    1007: Result:='Maximum Extended';
    else Result:=IntToStr(AValue);
  end;
end;

procedure TForm1.bCMClick(Sender: TObject);
begin
  WinExec('control keymgr.dll',SW_SHOWDEFAULT);
end;

procedure TForm1.bRunAsAdminClick(Sender: TObject);
begin
  if RunAsAdmin(Handle,Application.ExeName,'') then
    Close;
end;

procedure TForm1.bSaveClick(Sender: TObject);
var
  wh: Boolean;
begin
  wh:=True;
  sd.FileName:=MachineName+cSIFExt;
  if sd.Execute then
    NC.SaveToStorage(sd.FileName,wh);
end;

procedure TForm1.bBackupClick(Sender: TObject);
begin
  if not sdb.Execute then
    Exit;
  NC.BackupCreds(sdb.FileName);
end;

procedure TForm1.bCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.cmRefresh(Sender: TObject);
var
  i: Integer;
begin
  Memo.Clear;
  NC:=TMiTeC_NetCreds.Create(Self);
  NC.RefreshData;
  List.Items.Clear;
  for i:=0 to NC.RecordCount-1 do
    with List.Items.Add do begin
      Caption:=GetTypeStr(NC.Records[i].Typ);
      SubItems.Add(DateTimeToStr(NC.Records[i].Timestamp));
      SubItems.Add(NC.Records[i].Target);
      SubItems.Add(NC.Records[i].Username);
      SubItems.Add(NC.Records[i].Password);
    end;

  Caption:=Format('Network Credentials - %d items',[List.Items.Count]);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  bRunAsAdmin.Visible:=not IsRunningAsAdmin;
  cmRefresh(nil);
end;

procedure TForm1.ListSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
begin
  Memo.Clear;
  if not Assigned(Item) then
    Exit;
  Memo.Lines.Add(Format('Type: %s',[GetTypeStr(NC.Records[Item.Index].Typ)]));
  Memo.Lines.Add(Format('Timestamp: %s',[DateTimeToStr(NC.Records[Item.Index].Timestamp)]));
  Memo.Lines.Add(Format('Target: %s',[NC.Records[Item.Index].Target]));
  Memo.Lines.Add(Format('Username: %s',[NC.Records[Item.Index].UserName]));
  Memo.Lines.Add(Format('Password: %s',[NC.Records[Item.Index].Password]));
  Memo.SelStart:=0;
  Memo.SelLength:=0;
end;

end.
