unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, MSI_MUS;

const
  WM_REFRESH = WM_USER+1;

type
  TwndMain = class(TForm)
    pc: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    lvAU: TListView;
    lvUH: TListView;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    MUS: TMiTeC_MUS;
    procedure RefreshData;
  protected
    procedure WMREFRESH(var AMsg: TMessage); message WM_REFRESH;
  public
  end;

var
  wndMain: TwndMain;

implementation

uses MiTeC_StrUtils, TypInfo;

{$R *.dfm}

procedure TwndMain.FormCreate(Sender: TObject);
begin
  MUS:=TMiTeC_MUS.Create(Self);
end;

procedure TwndMain.FormShow(Sender: TObject);
begin
  PostMessage(Handle,WM_REFRESH,0,0);
end;

procedure TwndMain.RefreshData;
var
  i: integer;
begin
  SCreen.Cursor:=crHourglass;
  try
    lvAU.Items.Clear;
    lvUH.Items.Clear;
    MUS.RefreshData;
    for i:=0 to MUS.AvailableUpdateCount-1 do
      with lvAU.Items.Add do begin
        Caption:=MUS.AvailableUpdates[i].Title;
        SubItems.Add(NormalizeDataValue(MUS.AvailableUpdates[i].Size));
        Subitems.Add(MUS.AvailableUpdates[i].Severity);
        Subitems.Add(BoolToStr(MUS.AvailableUpdates[i].Downloaded,True));
        Subitems.Add(BoolToStr(MUS.AvailableUpdates[i].Installed,True));
      end;
    for i:=0 to MUS.UpdateHistoryCount-1 do
      with lvUH.Items.Add do begin
        Caption:=MUS.UpdateHistory[i].Title;
        SubItems.Add(DateTimeToStr(MUS.UpdateHistory[i].InstallDate));
        Subitems.Add(Copy(GetEnumName(TypeInfo(TOperationResultCode),integer(MUS.UpdateHistory[i].ResultCode)),4));
      end;
  finally
    Screen.Cursor:=crDefault;
  end;
end;

procedure TwndMain.WMREFRESH(var AMsg: TMessage);
begin
  RefreshData;
end;

end.
