unit Main;

{$MODE Delphi}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, MSI_PerfMon, MSI_Display;

type

  { TwndMain }

  TwndMain = class(TForm)
    lWarn: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure PerfMonThreadInterval(Sender: TPerfMonThread);
  private
    FDisplay: TMiTeC_Display;
    FPM: TPerfMonThread;
  public
  end;

var
  wndMain: TwndMain;

implementation

uses MiTeC_StrUtils;

{$R *.lfm}

procedure TwndMain.FormCreate(Sender: TObject);
const
  cGPUU = '\GPU Engine(*)\Utilization Percentage';
var
  i: Integer;
  l: TLabel;
  g: TProgressbar;
begin
  FDisplay:=TMiTeC_Display.Create(Self);
  FDisplay.RefreshData;
  FPM:=TPerfMonThread.Create;
  FPM.AddGPUMonitoringCounters;
  FPM.OnInterval:=PerfMonThreadInterval;
  FPM.GPUMonitoringActive:=FPM.CounterExists(cGPUU,False);
  if FPM.GPUMonitoringActive then begin
    for i:=0 to FDisplay.AdapterCount-1 do begin
      l:=TLabel.Create(Self);
      l.Parent:=Self;
      l.Caption:=Format('GPU %d - %s',[i,FDisplay.Adapter[i].Name]);
      l.Top:=(l.Height+8)*i+10;
      l.Left:=10;
      g:=TProgressbar.Create(Self);
      g.Tag:=i;
      g.Name:=Format('Gauge%d',[i]);
      g.Parent:=Self;
      g.Top:=l.Top;
      g.Left:=l.Left+l.Canvas.TextWidth(l.Caption)+5;
      g.Height:=l.Height+2;
      g.Width:=Self.ClientWidth-g.Left-10;
    end;
    Self.ClientHeight:=l.Top+l.Height*2;
    FPM.Suspended:=False;
  end else
    lWarn.Show;
  Update;
end;

procedure TwndMain.PerfMonThreadInterval(Sender: TPerfMonThread);
var
  i: Integer;
  g: TProgressbar;
begin
  for i:=0 to FDisplay.AdapterCount-1 do begin
    g:=TProgressbar(FindComponent(Format('Gauge%d',[i])));
    if Assigned(g) then
      g.Position:=Round(Sender.GPU[FDisplay.Adapter[i].LUID].Utilization);
  end;
end;

end.
